Index: issm/trunk-jpl/src/c/analyses/EnthalpyAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/EnthalpyAnalysis.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/analyses/EnthalpyAnalysis.cpp	(revision 18521)
@@ -880,5 +880,5 @@
 		/*Drain excess water fraction in ice column: */
 		for(i=0;i<femmodel->elements->Size();i++){
-			Element* element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+			Element* element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 			DrainWaterfractionIcecolumn(element);
 		}
@@ -888,5 +888,5 @@
 		/*Compute basal melting rates: */
 		for(i=0;i<femmodel->elements->Size();i++){
-			Element* element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+			Element* element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 			ComputeBasalMeltingrate(element);
 		}
@@ -898,5 +898,5 @@
 		if(solution_type==TransientSolutionEnum){
 			for(i=0;i<femmodel->elements->Size();i++){
-				Element* element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+				Element* element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 				UpdateBasalConstraints(element);
 			}
Index: issm/trunk-jpl/src/c/analyses/ExtrapolationAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/ExtrapolationAnalysis.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/analyses/ExtrapolationAnalysis.cpp	(revision 18521)
@@ -350,5 +350,5 @@
 
 	for(int i=0;i<femmodel->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 		this->SetConstraintsOnIce(element);
 	}
Index: issm/trunk-jpl/src/c/analyses/FreeSurfaceBaseAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/FreeSurfaceBaseAnalysis.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/analyses/FreeSurfaceBaseAnalysis.cpp	(revision 18521)
@@ -377,5 +377,5 @@
 	for(int i=0;i<femmodel->elements->Size();i++){
 
-		Element* element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 		if(!element->IsOnBase()) continue;
 
Index: issm/trunk-jpl/src/c/analyses/HydrologyDCInefficientAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/HydrologyDCInefficientAnalysis.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/analyses/HydrologyDCInefficientAnalysis.cpp	(revision 18521)
@@ -692,5 +692,5 @@
 
 	for(int i=0;i<femmodel->elements->Size();i++){
-		element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 
 		int numvertices = element->GetNumberOfVertices();
Index: issm/trunk-jpl/src/c/analyses/LevelsetAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/LevelsetAnalysis.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/analyses/LevelsetAnalysis.cpp	(revision 18521)
@@ -399,5 +399,5 @@
 	/* set NaN on elements intersected by zero levelset */
 	for(i=0;i<femmodel->elements->Size();i++){
-		element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 		if(element->IsZeroLevelset(MaskIceLevelsetEnum))
 			for(k=0;k<element->GetNumberOfVertices();k++)
@@ -407,5 +407,5 @@
 	/* set distance on elements intersected by zero levelset */
 	for(i=0;i<femmodel->elements->Size();i++){
-		element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 		if(element->IsZeroLevelset(MaskIceLevelsetEnum)){
 			SetDistanceToZeroLevelsetElement(vec_dist_zerolevelset, element);
Index: issm/trunk-jpl/src/c/analyses/LsfReinitializationAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/LsfReinitializationAnalysis.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/analyses/LsfReinitializationAnalysis.cpp	(revision 18521)
@@ -369,5 +369,5 @@
 	/* deactivate all spcs */
 	for(i=0;i<femmodel->elements->Size();i++){
-		element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 		for(k=0;k<element->GetNumberOfNodes();k++){
 			node=element->GetNode(k);
@@ -382,5 +382,5 @@
 	/* reactivate spcs on elements intersected by zero levelset */
 	for(i=0;i<femmodel->elements->Size();i++){
-		element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 		if(element->IsZeroLevelset(MaskIceLevelsetEnum)){
 			/*iterate over nodes and set spc */
@@ -414,5 +414,5 @@
 	/* set distance on elements intersected by zero levelset */
 	for(i=0;i<femmodel->elements->Size();i++){
-		element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 		if(element->IsZeroLevelset(MaskIceLevelsetEnum)){
 			SetDistanceToZeroLevelsetElement(vec_dist_zerolevelset, element);
Index: issm/trunk-jpl/src/c/analyses/MasstransportAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/MasstransportAnalysis.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/analyses/MasstransportAnalysis.cpp	(revision 18521)
@@ -796,5 +796,5 @@
 	/*Create and assemble matrix*/
 	for(int i=0;i<femmodel->elements->Size();i++){
-		Element*       element = dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		Element*       element = xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 		ElementMatrix* MLe     = this->CreateMassMatrix(element);
 		if(MLe){
@@ -817,5 +817,5 @@
 	/*Create and assemble matrix*/
 	for(int i=0;i<femmodel->elements->Size();i++){
-		Element*       element = dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		Element*       element = xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 		ElementMatrix* MLe     = this->CreateMassMatrix(element);
 		if(MLe){
@@ -880,5 +880,5 @@
 	/*Create and assemble matrix*/
 	for(int i=0;i<femmodel->elements->Size();i++){
-		Element*       element = dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		Element*       element = xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 		ElementMatrix* Ke     = this->CreateFctKMatrix(element);
 		if(Ke) Ke->AddToGlobal(Kff,Kfs);
Index: issm/trunk-jpl/src/c/analyses/SeaiceAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/SeaiceAnalysis.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/analyses/SeaiceAnalysis.cpp	(revision 18521)
@@ -372,5 +372,5 @@
 	mask=new Vector<IssmDouble>(femmodel->nodes->NumberOfNodes(SeaiceAnalysisEnum));
 	for (int i=0;i<femmodel->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 
 		/*Get current concentration of element and decide whether it is an active element*/
@@ -390,5 +390,5 @@
 	int counter =0;
 	for(int i=0;i<femmodel->nodes->Size();i++){
-		Node* node=dynamic_cast<Node*>(femmodel->nodes->GetObjectByOffset(i));
+		Node* node=xDynamicCast<Node*>(femmodel->nodes->GetObjectByOffset(i));
 		if(node->InAnalysis(SeaiceAnalysisEnum)){
 			if(serial_mask[node->Sid()]==1.){
@@ -552,5 +552,5 @@
 	/*Loop over the elements of this partition and update accordingly*/
 	for(int i=0;i<femmodel->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 
 		/*Get Mohr-Coulomb parameters*/
@@ -644,5 +644,5 @@
 	/*Loop over the elements of this partition and update accordingly*/
 	for(int i=0;i<femmodel->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 
 		/*Get some inputs needed for the update*/
Index: issm/trunk-jpl/src/c/analyses/StressbalanceAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/StressbalanceAnalysis.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/analyses/StressbalanceAnalysis.cpp	(revision 18521)
@@ -5032,5 +5032,5 @@
 
 	for(int i=0;i<elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 
 		/*Get inputs and parameters*/
@@ -5206,5 +5206,5 @@
 
 	for(int i=0;i<elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 
 		/*Get inputs and parameters*/
@@ -5419,5 +5419,5 @@
 
 	for(int i=0;i<elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 
 		/*Get inputs and parameters*/
@@ -6788,5 +6788,5 @@
 	/*Cast gauss to GaussPenta*/
 	_assert_(gauss_in->Enum()==GaussPentaEnum);
-	GaussPenta* gauss = dynamic_cast<GaussPenta*>(gauss_in);
+	GaussPenta* gauss = xDynamicCast<GaussPenta*>(gauss_in);
 
 	/*Get basis in actual coordinate system: */
@@ -6837,5 +6837,5 @@
 	/*Cast gauss to GaussPenta*/
 	_assert_(gauss_in->Enum()==GaussPentaEnum);
-	GaussPenta* gauss = dynamic_cast<GaussPenta*>(gauss_in);
+	GaussPenta* gauss = xDynamicCast<GaussPenta*>(gauss_in);
 
 	/*Get basis in actual coordinate system: */
@@ -6936,5 +6936,5 @@
 	/*Cast gauss to GaussPenta*/
 	_assert_(gauss_in->Enum()==GaussPentaEnum);
-	GaussPenta* gauss = dynamic_cast<GaussPenta*>(gauss_in);
+	GaussPenta* gauss = xDynamicCast<GaussPenta*>(gauss_in);
 
 	/*Get basis in actual coordinate system: */
@@ -6974,5 +6974,5 @@
 	/*Cast gauss to GaussPenta*/
 	_assert_(gauss_in->Enum()==GaussPentaEnum);
-	GaussPenta* gauss = dynamic_cast<GaussPenta*>(gauss_in);
+	GaussPenta* gauss = xDynamicCast<GaussPenta*>(gauss_in);
 
 	/*Get basis in actual coordinate system: */
Index: issm/trunk-jpl/src/c/classes/Elements/Elements.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/Elements.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Elements/Elements.cpp	(revision 18521)
@@ -41,5 +41,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		element=dynamic_cast<Element*>((*object));
+		element=xDynamicCast<Element*>((*object));
 		element->Configure(elements,loads,nodes,vertices,materials,parameters);
 
@@ -55,5 +55,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		element=dynamic_cast<Element*>((*object));
+		element=xDynamicCast<Element*>((*object));
 		element->SetCurrentConfiguration(elements,loads,nodes,materials,parameters);
 
@@ -69,5 +69,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		element=dynamic_cast<Element*>((*object));
+		element=xDynamicCast<Element*>((*object));
 		element->ResetHooks();
 
@@ -85,5 +85,5 @@
 	for(int i=0;i<this->Size();i++){
 
-		Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->GetObjectByOffset(i));
 		numnodes=element->GetNumberOfNodes();
 		if(numnodes>max)max=numnodes;
@@ -111,5 +111,5 @@
 
 	for(int i=0;i<this->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->GetObjectByOffset(i));
 		element->InputDuplicate(input_enum,output_enum);
 	}
Index: issm/trunk-jpl/src/c/classes/Elements/Penta.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/Penta.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Elements/Penta.cpp	(revision 18521)
@@ -1970,5 +1970,5 @@
 	tria->parameters=this->parameters;
 	tria->element_type=P1Enum; //Only P1 CG for now (TO BE CHANGED)
-	this->SpawnTriaHook(dynamic_cast<ElementHook*>(tria),index1,index2,index3);
+	this->SpawnTriaHook(xDynamicCast<ElementHook*>(tria),index1,index2,index3);
 
 	/*Spawn material*/
Index: issm/trunk-jpl/src/c/classes/Elements/PentaRef.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/PentaRef.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Elements/PentaRef.cpp	(revision 18521)
@@ -48,5 +48,5 @@
 	/*Cast gauss to GaussPenta*/
 	_assert_(gauss_in->Enum()==GaussPentaEnum);
-	GaussPenta* gauss = dynamic_cast<GaussPenta*>(gauss_in);
+	GaussPenta* gauss = xDynamicCast<GaussPenta*>(gauss_in);
 
 	/*Figure out xi,eta and zi (parametric coordinates), for this gaussian point: */
@@ -160,5 +160,5 @@
 	/*Cast gauss to GaussPenta*/
 	_assert_(gauss_in->Enum()==GaussPentaEnum);
-	GaussPenta* gauss = dynamic_cast<GaussPenta*>(gauss_in);
+	GaussPenta* gauss = xDynamicCast<GaussPenta*>(gauss_in);
 
 	/*Get current coordinates in reference element*/
@@ -365,5 +365,5 @@
 	/*Cast gauss to GaussPenta*/
 	_assert_(gauss_in->Enum()==GaussPentaEnum);
-	GaussPenta* gauss = dynamic_cast<GaussPenta*>(gauss_in);
+	GaussPenta* gauss = xDynamicCast<GaussPenta*>(gauss_in);
 
 	/*Get current coordinates in reference element*/
Index: issm/trunk-jpl/src/c/classes/Elements/Tetra.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/Tetra.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Elements/Tetra.cpp	(revision 18521)
@@ -824,5 +824,5 @@
 	tria->parameters=this->parameters;
 	tria->element_type=P1Enum; //Only P1 CG for now (TO BE CHANGED)
-	this->SpawnTriaHook(dynamic_cast<ElementHook*>(tria),index1,index2,index3);
+	this->SpawnTriaHook(xDynamicCast<ElementHook*>(tria),index1,index2,index3);
 
 	/*Spawn material*/
Index: issm/trunk-jpl/src/c/classes/Elements/TetraRef.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/TetraRef.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Elements/TetraRef.cpp	(revision 18521)
@@ -37,5 +37,5 @@
 	/*Cast gauss to GaussTetra*/
 	_assert_(gauss_in->Enum()==GaussTetraEnum);
-	GaussTetra* gauss = dynamic_cast<GaussTetra*>(gauss_in);
+	GaussTetra* gauss = xDynamicCast<GaussTetra*>(gauss_in);
 
 	switch(finiteelement){
Index: issm/trunk-jpl/src/c/classes/Elements/Tria.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/Tria.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Elements/Tria.cpp	(revision 18521)
@@ -1796,5 +1796,5 @@
 	seg->parameters=this->parameters;
 	seg->element_type=P1Enum; //Only P1 CG for now (TO BE CHANGED)
-	this->SpawnSegHook(dynamic_cast<ElementHook*>(seg),index1,index2);
+	this->SpawnSegHook(xDynamicCast<ElementHook*>(seg),index1,index2);
 
 	/*Spawn material*/
Index: issm/trunk-jpl/src/c/classes/Elements/TriaRef.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/TriaRef.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Elements/TriaRef.cpp	(revision 18521)
@@ -146,5 +146,5 @@
 	/*Cast gauss to GaussTria*/
 	_assert_(gauss_in->Enum()==GaussTriaEnum);
-	GaussTria* gauss = dynamic_cast<GaussTria*>(gauss_in);
+	GaussTria* gauss = xDynamicCast<GaussTria*>(gauss_in);
 
 	switch(finiteelement){
@@ -271,5 +271,5 @@
 	/*Cast gauss to GaussTria*/
 	_assert_(gauss_in->Enum()==GaussTriaEnum);
-	GaussTria* gauss = dynamic_cast<GaussTria*>(gauss_in);
+	GaussTria* gauss = xDynamicCast<GaussTria*>(gauss_in);
 
 	switch(finiteelement){
Index: issm/trunk-jpl/src/c/classes/ExternalResults/Results.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/ExternalResults/Results.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/ExternalResults/Results.cpp	(revision 18521)
@@ -41,5 +41,5 @@
 
 	for(int i=0;i<this->Size();i++){
-		ExternalResult* result=dynamic_cast<ExternalResult*>(this->GetObjectByOffset(i));
+		ExternalResult* result=xDynamicCast<ExternalResult*>(this->GetObjectByOffset(i));
 		result->WriteData(fid,io_gather);
 	}
@@ -57,5 +57,5 @@
 
 	for(int i=0;i<this->Size();i++){
-		ExternalResult* result=dynamic_cast<ExternalResult*>(this->GetObjectByOffset(i));
+		ExternalResult* result=xDynamicCast<ExternalResult*>(this->GetObjectByOffset(i));
 
 		if(result->GetStep()==in_result->GetStep()){
@@ -81,5 +81,5 @@
 
 	for(int i=0;i<this->Size();i++){
-		ExternalResult* result=dynamic_cast<ExternalResult*>(this->GetObjectByOffset(i));
+		ExternalResult* result=xDynamicCast<ExternalResult*>(this->GetObjectByOffset(i));
 
 		if(result->GetStep()==result_step){
Index: issm/trunk-jpl/src/c/classes/FemModel.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/FemModel.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/FemModel.cpp	(revision 18521)
@@ -603,5 +603,5 @@
 					/*Get interpolation (and compute input if necessary)*/
 					for(int j=0;j<elements->Size();j++){
-						Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(j));
+						Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(j));
 						element->ResultInterpolation(&rank_interpolation,&rank_nodesperelement,output_enum);
 					}
@@ -622,5 +622,5 @@
 						/*Fill-in matrix*/
 						for(int j=0;j<elements->Size();j++){
-							Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(j));
+							Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(j));
 							element->ResultToPatch(values,nodesperelement,output_enum);
 						}
@@ -739,5 +739,5 @@
 
 	for (i=1;i<elements->Size();i++){
-		element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+		element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 		dt=element->TimeAdapt();
 		if(dt<min_dt)min_dt=dt;
@@ -756,5 +756,5 @@
 
 	for(int i=0;i<elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 		element->UpdateConstraintsExtrudeFromBase();
 	}
@@ -765,5 +765,5 @@
 
 	for(int i=0;i<elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 		element->UpdateConstraintsExtrudeFromTop();
 	}
@@ -839,5 +839,5 @@
 	maxabsvx=-INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		element_maxabsvx=element->inputs->MaxAbs(VxEnum);
 		if(element_maxabsvx>maxabsvx) maxabsvx=element_maxabsvx;
@@ -863,5 +863,5 @@
 	maxabsvy=-INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		element_maxabsvy=element->inputs->MaxAbs(VyEnum);
 		if(element_maxabsvy>maxabsvy) maxabsvy=element_maxabsvy;
@@ -887,5 +887,5 @@
 	maxabsvz=-INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		element_maxabsvz=element->inputs->MaxAbs(VzEnum);
 		if(element_maxabsvz>maxabsvz) maxabsvz=element_maxabsvz;
@@ -911,5 +911,5 @@
 	maxvel=-INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		element_maxvel = element->inputs->Max(VelEnum);
 		if(element_maxvel>maxvel) maxvel=element_maxvel;
@@ -935,5 +935,5 @@
 	maxvx=-INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		element_maxvx = element->inputs->Max(VxEnum);
 		if(element_maxvx>maxvx) maxvx=element_maxvx;
@@ -959,5 +959,5 @@
 	maxvy=-INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		element_maxvy = element->inputs->Max(VyEnum);
 		if(element_maxvy>maxvy) maxvy=element_maxvy;
@@ -983,5 +983,5 @@
 	maxvz=-INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		element_maxvz = element->inputs->Max(VzEnum);
 		if(element_maxvz>maxvz) maxvz=element_maxvz;
@@ -1007,5 +1007,5 @@
 	minvel=INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		element_minvel = element->inputs->Min(VelEnum);
 		if(element_minvel<minvel) minvel=element_minvel;
@@ -1031,5 +1031,5 @@
 	minvx=INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		element_minvx = element->inputs->Min(VxEnum);
 		if(element_minvx<minvx) minvx=element_minvx;
@@ -1055,5 +1055,5 @@
 	minvy=INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		element_minvy = element->inputs->Min(VyEnum);
 		if(element_minvy<minvy) minvy=element_minvy;
@@ -1079,5 +1079,5 @@
 	minvz=INFINITY;
 	for(i=0;i<this->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		element_minvz = element->inputs->Min(VzEnum);
 		if(element_minvz<minvz) minvz=element_minvz;
@@ -1099,5 +1099,5 @@
 
 	for(int i=0;i<this->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		local_smb+=element->TotalSmb();
 	}
@@ -1115,5 +1115,5 @@
 
 	for(int i=0;i<this->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		local_divergence+=element->Divergence();
 	}
@@ -1143,5 +1143,5 @@
 
 	for(int i=0;i<this->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		element->GetInputLocalMinMaxOnNodes(uLmin_local,uLmax_local,ug);
 	}
@@ -1164,5 +1164,5 @@
 
 	for(int i=0;i<this->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		local_ice_volume+=element->IceVolume();
 	}
@@ -1180,5 +1180,5 @@
 
 	for(int i=0;i<this->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		local_ice_volume_af+=element->IceVolumeAboveFloatation();
 	}
@@ -1205,5 +1205,5 @@
 	/*now, go through our elements, and retrieve the one with this id: index: */
 	for(int i=0;i<this->elements->Size();i++){
-		element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
+		element=xDynamicCast<Element*>(this->elements->GetObjectByOffset(i));
 		if (element->Id()==index){
 			found=1;
@@ -1243,5 +1243,5 @@
 	/*Compute Misfit: */
 	for(int i=0;i<elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 
 		/*If on water, return 0: */
@@ -1311,5 +1311,5 @@
 	/*Compute Misfit: */
 	for(int i=0;i<elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 
 		/*If on water, return 0: */
@@ -1341,5 +1341,5 @@
 	/*Compute Misfit: */
 	for(int i=0;i<elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 
 		/*If on water, return 0: */
@@ -1572,5 +1572,5 @@
 	/*Go through elements, and add contribution from each element to the deflection vector wg:*/
 	for(int i=0;i<elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 		element->GiaDeflection(wg,dwgdt, x,y);
 	}
@@ -1590,5 +1590,5 @@
 
 	for (int i=0;i<elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 		effanalysis->HydrologyEPLGetMask(mask,element);
 	}
@@ -1606,5 +1606,5 @@
 	active=new Vector<IssmDouble>(nodes->NumberOfNodes(HydrologyDCEfficientAnalysisEnum));
 	for (int i=0;i<elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 		effanalysis->HydrologyEPLGetActive(active,element);
 	}
@@ -1618,5 +1618,5 @@
 	int counter =0;
 	for (int i=0;i<nodes->Size();i++){
-		Node* node=dynamic_cast<Node*>(nodes->GetObjectByOffset(i));
+		Node* node=xDynamicCast<Node*>(nodes->GetObjectByOffset(i));
 		if(node->InAnalysis(HydrologyDCEfficientAnalysisEnum)){
 			if(serial_active[node->Sid()]==1.){
@@ -1651,5 +1651,5 @@
 	active=new Vector<IssmDouble>(nodes->NumberOfNodes(HydrologyDCEfficientAnalysisEnum));
 	for (int i=0;i<elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 		effanalysis->HydrologyEPLGetActive(active,element);
 	}
@@ -1664,5 +1664,5 @@
 	int counter =0;
 	for (int i=0;i<nodes->Size();i++){
-		Node* node=dynamic_cast<Node*>(nodes->GetObjectByOffset(i));
+		Node* node=xDynamicCast<Node*>(nodes->GetObjectByOffset(i));
 		if(node->InAnalysis(L2ProjectionEPLAnalysisEnum)){
 			if(serial_active[node->Sid()]==1.){
Index: issm/trunk-jpl/src/c/classes/Hook.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Hook.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Hook.cpp	(revision 18521)
@@ -168,5 +168,5 @@
 		/*Now, for this->objects that did not get resolved, and for which we have no offset, chase them in the dataset, by id: */
 		if(this->objects[i]==NULL){
-			this->objects[i]=dynamic_cast<Object*>(dataset->GetObjectById(this->offsets+i,this->ids[i])); //remember the offset for later on.
+			this->objects[i]=xDynamicCast<Object*>(dataset->GetObjectById(this->offsets+i,this->ids[i])); //remember the offset for later on.
 			/*check the id is correct!: */
 			if (this->objects[i]->Id()!=this->ids[i]) _error_("wrong id: " << this->objects[i]->Id() << " vs " << this->ids[i] << "  in resolved pointer!");
Index: issm/trunk-jpl/src/c/classes/Inputs/ControlInput.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Inputs/ControlInput.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Inputs/ControlInput.cpp	(revision 18521)
@@ -87,9 +87,9 @@
 	output->control_id=this->control_id;
 
-	if(values)      output->values      = dynamic_cast<Input*>(this->values->copy());
-	if(savedvalues) output->savedvalues = dynamic_cast<Input*>(this->savedvalues->copy());
-	if(minvalues)   output->minvalues   = dynamic_cast<Input*>(this->minvalues->copy());
-	if(maxvalues)   output->maxvalues   = dynamic_cast<Input*>(this->maxvalues->copy());
-	if(gradient)    output->gradient    = dynamic_cast<Input*>(this->gradient->copy());
+	if(values)      output->values      = xDynamicCast<Input*>(this->values->copy());
+	if(savedvalues) output->savedvalues = xDynamicCast<Input*>(this->savedvalues->copy());
+	if(minvalues)   output->minvalues   = xDynamicCast<Input*>(this->minvalues->copy());
+	if(maxvalues)   output->maxvalues   = xDynamicCast<Input*>(this->maxvalues->copy());
+	if(gradient)    output->gradient    = xDynamicCast<Input*>(this->gradient->copy());
 
 	return output;
@@ -234,5 +234,5 @@
 
 	if(savedvalues) delete this->savedvalues;
-	this->savedvalues=dynamic_cast<Input*>(this->values->copy());
+	this->savedvalues=xDynamicCast<Input*>(this->values->copy());
 }/*}}}*/
 void ControlInput::UpdateValue(IssmDouble scalar){/*{{{*/
@@ -241,5 +241,5 @@
 
 	if(values) delete this->values;
-	this->values=dynamic_cast<Input*>(this->savedvalues->copy());
+	this->values=xDynamicCast<Input*>(this->savedvalues->copy());
 	this->values->AXPY(gradient,scalar);
 }/*}}}*/
Index: issm/trunk-jpl/src/c/classes/Inputs/DatasetInput.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Inputs/DatasetInput.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Inputs/DatasetInput.cpp	(revision 18521)
@@ -81,5 +81,5 @@
 	outinput=new DatasetInput();
 	outinput->enum_type=this->enum_type;
-	outinput->inputs=dynamic_cast<Inputs*>(this->inputs->SpawnTriaInputs(index1,index2,index3));
+	outinput->inputs=xDynamicCast<Inputs*>(this->inputs->SpawnTriaInputs(index1,index2,index3));
 	outinput->numids=this->numids;
 	outinput->ids=xNew<int>(this->numids);
@@ -98,5 +98,5 @@
 	outinput=new DatasetInput();
 	outinput->enum_type=this->enum_type;
-	outinput->inputs=dynamic_cast<Inputs*>(this->inputs->SpawnSegInputs(index1,index2));
+	outinput->inputs=xDynamicCast<Inputs*>(this->inputs->SpawnSegInputs(index1,index2));
 	outinput->numids=this->numids;
 	outinput->ids=xNew<int>(this->numids);
@@ -157,5 +157,5 @@
 	if(offset<0) _error_("Could not find input of id "<<id );
 
-	Input* input=dynamic_cast<Input*>(this->inputs->GetObjectByOffset(offset));
+	Input* input=xDynamicCast<Input*>(this->inputs->GetObjectByOffset(offset));
 	input->GetInputValue(pvalue,gauss);
 }
